#include <stdlib.h>
#include <stdio.h>

int main (int argc, char **argv) {
 unsigned long i, i_0 = 0, i_1 = 0xffff, di = 0x10, j = 0xf000;
 unsigned char *mem;

 puts ("PnP Hardware Scanner 1.0 Alpha");
 puts ("Copyright (R) 2019  Asterix");
 puts ("Released to the Public Domain");
 if (1 < argc) {
  printf ("\nUsage: %s\n", argv[0]);
  return 1;
 }

 for (i = i_0; i <= i_1; i += di) {
  mem = (void *) (j * 0x10000 + i);
  if ('$' == mem[0] && 'P' == mem[1] && 'n' == mem[2] && 'P' == mem[3]) {
   printf ("\nPnP Device Found at %p\n", mem);
   printf ("Signature: %c%c%c%c\n", mem[0], mem[1], mem[2], mem[3]);
   printf ("Version: %hhx\n", mem[4]);
   printf ("Length: %hhd\n", mem[5]);
   printf ("Control Field: %d\n", mem[6]);
   printf ("Checksum: %hhx\n", mem[8]);
   printf ("Event Notification Flag Address: %lx\n", mem[9]);
   printf ("Real Mode 16-Bit Offset to Entry Point: %x\n", mem[0xd]);
   printf ("Real Mode 16-Bit Code Segment Address: %x\n", mem[0xf]);
   printf ("16-Bit Protected Mode Offset to Entry Point: %x\n", mem[0x11]);
   printf ("16-Bit Protected Mode Code Segment Base Address: %lx\n", mem[0x13]);
   printf ("OEM Device Identifier: %lx\n", mem[0x17]);
   printf ("Real Mode 16-Bit Data Segment Address: %x\n", mem[0x1B]);
   printf ("16-Bit Protected Mode Data Segment Base Address: %lx\n", mem[0x1d]);
  }
 }

 return 0;
}